<template>
  <!--
      :accept="'application/pdf'"
      -->
  <div>
    <v-dialog v-model="mostrarAdvertencia" persistent max-width="800">
      <v-card>
        <div class="contSecc">
          <div class="titSec font-size-13">Advertencia</div>
          <div class="gris">
            <div class="titCol titDialog">¿Estas seguro de eliminar el archivo?</div>
          </div>
        </div>
        <div class="btnCenter">
          <button class="btn btnG" @click="cancelarAlerta">Cancelar</button>
          <button class="btn" @click="eliminarArchivo">Aceptar</button>
        </div>
      </v-card>
    </v-dialog>
    <vue-file-agent
      :multiple="true"
      :deletable="deleteable"
      :editable="false"
      :meta="true"
      :maxSize="'15MB'"
      :theme="'list'"
      :maxFiles="25"
      :auto="false"
      :linkable="false"
      class="upload-block"
      :readonly="readonly"
      :sortable="sortable"
      :helpText="'Arrastra tu archivo aquí o selecciónalo aquí'"
      :errorText="{
        type: 'Formato del archivo no permitido',
        size: 'Los archivos no pueden pasar mas de 10MB',
      }"
      @select="filesSelected($event)"
      @beforedelete="onBeforeDelete($event)"
      @delete="fileDeleted($event)"
      @sort="onSort($event)"
      @upload="onUpload($event)"
      @upload:error="onUploadError($event)"
      @upload:delete="onUploadDelete($event)"
      @upload:delete:error="onUploadDeleteError($event)"
      ref="vueFileAgent"
      v-model="fileRecords"
    >
      <template v-slot:file-preview="slotProps">
        <VueFilePreview
          :key="'ee' + slotProps.index"
          :value="slotProps.fileRecord"
          :deletable="deleteable"
          :linkable="true"
          class="file-preview-wrapper grid-box-item grid-block"
        ></VueFilePreview>
        <div class="actions">
          <v-chip color="white" :elevation="0" light fab x-small class="indice">
            {{ slotProps.index + 1 }}
          </v-chip>
          <v-btn
            v-if="deleteable"
            color="red"
            light
            tile
            x-small
            class="ma-0 pa-0 white--text delete"
            @click="removeFileRecord(slotProps.fileRecord)"
          >
            <v-icon small>mdi-delete</v-icon>
          </v-btn>
        </div>
      </template>
    </vue-file-agent>
  </div>
</template>
<style>
.actions {
  position: absolute;
  top: 0px;
  bottom: 0px;
  left: 0px;
  right: 0px;
}
.indice {
  z-index: 11;
  top: 4px;
  left: 13px;
  position: absolute;
  height: 11px !important;
}
.delete {
  z-index: 11;
  float: right;
}
.is-sortable-enabled.is-sortable-immediately
  .file-preview-wrapper.grid-box-item.grid-block:not(.file-preview-new) {
  border: 2px dashed #ffcd00;
  margin-top: 4px !important;
}
.is-sortable-enabled.is-sortable-immediately
  .file-preview-wrapper.grid-box-item.grid-block.file-preview-new {
  display: none;
}
.error-validation .vue-file-agent.file-input-wrapper {
  border: 2px dashed rgb(253, 81, 81);
}
.grid-block-wrapper.vue-file-agent.file-input-wrapper {
  z-index: 0;
}
</style>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceLocalStorage = store.state.serviceLocalStorage;
export default {
  name: "Component-Archivos2",
  props: ["value", "folio", "type", "datosGenerales", "idUsuario", "idNegocio"],
  data: () => ({
    sortable: false,
    deleteable: true,
    readonly: false,
    fileRecordToDelete: null,
    fileRecords: [],
    mostrarAdvertencia: false,
    fileAdvertenciaEliminado: null,
    timeRandom: {
      min: 100,
      max: 5000,
      old: 100,
    },
    uploadHeaders: {
      "Content-Type": "application/json",
      Authorization: "Bearer " + serviceLocalStorage.getAccessToken(),
    },
    fileRecordsForUpload: [],
  }),
  mounted() {
    this.precargarArchivos();
  },
  watch: {
    fileRecords(val, prev) {
      this.data.value = val;
    },
    sortable(val, prev) {
      this.readonly = val;
      this.deleteable = !val;
    },
  },
  computed: {
    uploadUrl() {
      let value =
        store.state.urlApiPlataformaFranquicia +
        "documento-sucursal/archivos/v1/" +
        this.folio.idFolio +
        "/archivos";
      return value;
    },
    data: {
      get() {
        return this.value;
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  methods: {
    removeFileRecord: function (fileRecord) {
      return this.$refs.vueFileAgent.removeFileRecord(fileRecord);
    },
    toBase64(file) {
      return new Promise((resolve, reject) => {
        const reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onload = () => resolve(reader.result);
        reader.onerror = (error) => reject(error);
      });
    },
    onUpload(responses) {
      for (let response of responses) {
        if (response.error) {
          continue;
        }
        let data = response.data;
        if (data) {
          let uid = data.resultado.uid;
          response.fileRecord.uid = uid;
          response.fileRecord.url = this.uploadUrl + "/" + uid + "/contenido";
          this.postArchivoVirtual(response.fileRecord);
        }
      }
    },
    onUploadError(failedResponses) {
      for (let failedResponse of failedResponses) {
        failedResponse.fileRecord.upload.error = "Error Inesperado...!";
      }
    },
    uploadFiles() {
      if (this.fileRecordsForUpload.length > 0) {
        this.$refs.vueFileAgent.upload(
          this.uploadUrl,
          this.uploadHeaders,
          this.fileRecordsForUpload,
          function createFormData(fileData) {
            let srcB64 = fileData.raw.srcB64;
            srcB64 = srcB64.split(",")[1];
            var extension = fileData.file.name.split(".")[1];
            var tipoContenido = fileData.file.type;
            if (extension == "dwg" || extension == "DWG") {
              tipoContenido = "image/x-dwg";
            }
            return (
              '{"nombre":"' +
              fileData.file.name +
              '","archivo":"' +
              srcB64 +
              '", "tipoContenido": "' +
              tipoContenido +
              '"}'
            );
          }
        );
        this.fileRecordsForUpload = [];
      }
    },
    async filesSelected(fileRecordsNewlySelected) {
      for (let fileRecordNewlySelected of fileRecordsNewlySelected) {
        const result = await this.toBase64(fileRecordNewlySelected.file).catch((e) =>
          Error(e)
        );
        if (result instanceof Error) {
          console.log("Error: ", result.message);
          return;
        }
        fileRecordNewlySelected.srcB64 = result;
        fileRecordNewlySelected.indice = this.fileRecords.length;
      }
      var validFileRecords = fileRecordsNewlySelected.filter(
        (fileRecord) => !fileRecord.error
      );
      this.fileRecordsForUpload = this.fileRecordsForUpload.concat(validFileRecords);
      this.uploadFiles();
    },
    onRemove(event, fileRecord) {
      this.onBeforeDelete(fileRecord.raw);
    },
    onBeforeDelete: function (fileRecord) {
      this.fileAdvertenciaEliminado = null;
      this.fileRecordToDelete = fileRecord;
      var i = this.fileRecordsForUpload.indexOf(fileRecord);
      if (i !== -1) {
        this.fileRecordsForUpload.splice(i, 1);
        var k = this.fileRecords.indexOf(fileRecord);
        if (k !== -1) this.fileRecords.splice(k, 1);
      } else {
        if (fileRecord.uid) {
          this.mostrarAdvertencia = true;
          this.fileAdvertenciaEliminado = fileRecord;
        } else {
          this.$refs.vueFileAgent.deleteFileRecord(fileRecord);
        }
      }
    },
    deleteUploadedFile: function (fileRecord) {
      this.$refs.vueFileAgent.deleteUpload(
        this.uploadUrl + "/" + fileRecord.uid,
        this.uploadHeaders,
        fileRecord,
        function createFormData(fileData) {
          return "";
        }
      );
    },
    fileDeleted: function (fileRecord) {
      var i = this.fileRecordsForUpload.indexOf(fileRecord);
      if (i !== -1) {
        this.fileRecordsForUpload.splice(i, 1);
      } else {
        this.deleteUploadedFile(fileRecord);
      }
    },
    onUploadDelete(response) {
      this.deleteArchivoVirtual(response.fileRecord);
    },
    onUploadDeleteError(event) {
      if (this.fileRecordToDelete.uid) {
        this.fileRecords.push(this.fileRecordToDelete);
      }
    },
    onSort(event) {
      let fileRecordOld = this.fileRecords[event.oldIndex];
      let fileRecordNew = this.fileRecords[event.newIndex];
      fileRecordNew.indice = event.newIndex;
      fileRecordOld.indice = event.oldIndex;
      this.putArchivoVirtual(fileRecordNew);
      this.putArchivoVirtual(fileRecordOld);
    },
    getFolioArchivosVirtuales() {
      var self = this;
      var negoArchivo = this.datosGenerales.dataUnidadNegocio.value.idNegocio;
      if (this.idNegocio != 0) {
        negoArchivo = this.idNegocio;
      }
      var negocioArchivo = negoArchivo;
      axios(
        "/documento-sucursal/virtuales-archivos/v1/busquedas/folio/" +
          this.folio.idFolio +
          "/documento/" +
          this.datosGenerales.dataDocumento.value.idDocumento
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            console.log(
              "Negocio ==>" +
                negocioArchivo +
                "----" +
                JSON.stringify(data.resultado.folioVirtualesArchivos)
            );
            data.resultado.folioVirtualesArchivos.forEach((itemArchivo) => {
              itemArchivo.type = itemArchivo.tipoContenido;
              itemArchivo.ext = itemArchivo.extension;
              itemArchivo.size = itemArchivo.peso;
              itemArchivo.name = itemArchivo.nombre;
              delete itemArchivo.nombre;
              delete itemArchivo.peso;
              delete itemArchivo.extension;
              delete itemArchivo.tipoContenido;
              delete itemArchivo.descripcion;
              if (negocioArchivo == itemArchivo.idNegocio) {
                self.fileRecords.push(itemArchivo);
              }
            });

            this.data.value = this.fileRecords;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {
          this.$emit("loaded", true);
        });
    },

    async postArchivoVirtual(file) {
      var tipoCont = file.type;
      let idUsr = this.idUsuario;
      if (file.ext == "dwg" || file.ext == "DWG") {
        tipoCont = "image/x-dwg";
      }
      var negocioArchivo = this.datosGenerales.dataUnidadNegocio.value.idNegocio;
      if (this.idNegocio != 0) {
        negocioArchivo = this.idNegocio;
      }
      const body = {
        uid: file.uid,
        nombre: file.name(),
        descripcion: file.name(),
        peso: file.size,
        extension: file.ext,
        tipo: this.type,
        tipoContenido: tipoCont,
        indice: file.indice,
        usuarioCreador: idUsr,
        idNegocio: negocioArchivo,
      };
      const self = this;
      console.log("body=>" + JSON.stringify(body));
      console.log("idFolio-=>" + JSON.stringify(this.folio.idFolio));

      var tiempo = this.getRandomArbitrary();
      this.timeRandom.old = tiempo;
      console.log(this.timeRandom.old);
      await this.sleep(tiempo);
      axios
        .post(
          "/documento-sucursal/virtuales-archivos/v1/" +
            this.folio.idFolio +
            "/virtuales/archivos",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            file.idArchivo = data.resultado.id;
            let temp = JSON.parse(JSON.stringify(self.data.value));
            self.data.value = temp;

            console.log("idArchivo-=>" + JSON.stringify(file.idArchivo));
            this.$emit("archivoCargado", file.idArchivo);
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    putArchivoVirtual(file) {
      console.log(file);
      const body = {
        uid: file.uid,
        nombre: file.name(),
        descripcion: file.name(),
        peso: file.size,
        extension: file.ext,
        tipo: this.type,
        tipoContenido: file.type,
        indice: file.indice,
      };
      axios
        .put(
          "/documento-sucursal/virtuales-archivos/v1/" +
            this.folio.idFolio +
            "/virtuales/archivos/" +
            file.idArchivo,
          body
        )
        .then((response) => {})
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    deleteArchivoVirtual(file) {
      axios
        .delete(
          "/documento-sucursal/virtuales-archivos/v1/" +
            this.folio.idFolio +
            "/virtuales/archivos/" +
            file.idArchivo
        )
        .then((response) => {
          this.$emit("archivoBorrado", file.idArchivo, this.folio.idFolio);
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },

    precargarArchivos() {
      console.log(this.folio);
      this.fileRecords = [];
      this.getFolioArchivosVirtuales();
    },
    cancelarAlerta() {
      this.mostrarAdvertencia = false;
    },
    eliminarArchivo() {
      this.mostrarAdvertencia = false;
      if (this.fileAdvertenciaEliminado != null) {
        this.$refs.vueFileAgent.deleteFileRecord(this.fileAdvertenciaEliminado); // will trigger 'delete' event
      }
    },

    sleep(milliseconds) {
      return new Promise((resolve) => setTimeout(resolve, milliseconds));
    },
    getRandomArbitrary() {
      var x = Math.trunc(
        Math.random() * (this.timeRandom.max - this.timeRandom.min) + this.timeRandom.min
      );
      if (Math.abs(x - this.timeRandom.old) <= 300) {
        return this.getRandomArbitrary();
      }
      return x;
    },
  },
  created() {},
};
</script>
